<template>
  <base-dialog :show="!!error" title="Wystąpił błąd!" @close="handleError">
    {{ error }}
  </base-dialog>
  <div v-if="isLoading">
    <base-spinner></base-spinner>
  </div>
  <div v-if="selectedScreening != null && !isLoading">
    <h1>{{ selectedScreening.movieTitle }}</h1>
    <h2>{{ showDateTime }}</h2>
    <section v-if="!payment">
      <div v-for="row in selectedScreening.hallRows" :key="row">
        <button
          :class="seatStyle(getIndex(row, column, getColumns))"
          v-for="column in getColumns"
          :key="column"
          @click="selectSeat(getIndex(row, column, getColumns))"
        ></button>
      </div>
    </section>
    <div v-if="payment">
      <Screening-payment
        :selected-seats="selectedSeats"
        :selected-screening="selectedScreening"
      ></Screening-payment>
    </div>
    <div v-if="selectedSeats.length > 0 && !payment">
      <Selected-seats
        :selected-seats="selectedSeats"
        :selected-screening="selectedScreening"
      ></Selected-seats>
      <br />
      <base-button @click="pay">Przejdź do płatności</base-button>
    </div>
  </div>
</template>

<script setup>
import SelectedSeats from "@/components/SelectedSeats.vue";
import ScreeningPayment from "@/components/ScreeningPayment.vue";
import { computed, defineProps, ref } from "vue";
import { useStore } from "vuex";
import { useRouter } from "vue-router";

const store = useStore();
const router = useRouter();

const props = defineProps(["id"]);

const error = ref(null);
const loadedSeats = ref([]);
const selectedSeats = ref([]);
const selectedScreening = ref(null);
const payment = ref(false);
const isLoading = ref(false);

const showDateTime = computed(function () {
  const date = selectedScreening.value.dateTime;
  return (
    date.substring(8, 10) +
    "." +
    date.substring(5, 7) +
    "." +
    date.substring(0, 4) +
    " " +
    date.substring(10, 16)
  );
});
const getColumns = computed(function () {
  return selectedScreening.value.hallColumns;
});

function handleError() {
  error.value = null;
}
function seatStyle(index) {
  if (loadedSeats.value[index] === 0) {
    return "seat";
  } else if (loadedSeats.value[index] === 1) {
    return "takenSeat";
  } else {
    return "selectedSeat";
  }
}
function getIndex(row, column, columns) {
  if (row === 1) {
    return column - 1;
  } else {
    return (row - 1) * columns + column - 1;
  }
}
function selectSeat(index) {
  console.log(index);
  if (loadedSeats.value[index] === 2) {
    selectedSeats.value.splice(selectedSeats.value.indexOf(index), 1);
    loadedSeats.value[index] = 0;
    console.log(selectedSeats.value);
  } else {
    if (loadedSeats.value[index] !== 1) {
      selectedSeats.value.push(index);
      loadedSeats.value[index] = 2;
      console.log(selectedSeats.value);
    }
  }
}
async function pay() {
  isLoading.value = true;
  try {
    payment.value = true;
    for (let i = 0; i < selectedSeats.value.length; i++) {
      loadedSeats.value[selectedSeats.value[i]] = 1;
    }
    await store.dispatch("takeSeats", {
      screeningId: selectedScreening.value.uuId,
      seats: selectedSeats.value,
    });
  } catch (error) {
    error.value = "Nie udało się załadować danych.";
  }
  isLoading.value = false;
}

try {
  selectedScreening.value = store.getters.screenings.find(
    (screening) => screening["id"] === props.id
  );
  loadedSeats.value = selectedScreening.value.seats;
} catch (error) {
  error.value = "Nie udało się załadować danych.";
}
if (selectedScreening.value === undefined) {
  router.replace("/notFound");
}
</script>

<style scoped>
h1,
h2 {
  margin-left: 1rem;
}
h2 {
  font-size: 1.2rem;
}

.seat,
.selectedSeat,
.takenSeat {
  border: none;
  width: 2rem;
  height: 2rem;
  margin: 0.5rem;
  padding: 0;
}
.seat {
  background-color: #3d008d;
  color: white;
}
.selectedSeat {
  background-color: #42b983;
  color: white;
}
.takenSeat {
  background-color: #424242;
  color: white;
}
.seat:hover,
.selectedSeat:hover {
  cursor: pointer;
}

div {
  margin: 0 0 0 1rem;
}
</style>
